(function () {
    
    function setUpWindowConfigurations() {
        // App version
        window.applicationVersion = moment().valueOf();
        
        // App initial language
        window.lang = 'pt_br';
        
        // Zeedhi's dependencies
        window.templateUrl = "./bower_components/zeedhi-frontend/templates/dyman/";
        window.serviceUrl = "../backend/" + "" + "index.php";
        window.metadataUrls = [];
        window.serviceUrls  = [];
        
        // Zeedhi framework docs path
        window.docsUrl = "../bower_components/zeedhi-frontend/docs/dyman/";
        
        // Zeedhi's DevTools configs
        window.metadataUrl = "assets";
        window.inDeveloperMode = false;
        
        // Odhen's CSS    
        window.cssUrl = "../../../assets/css/odhen.css?v=" + window.applicationVersion;
        window.cssStyle = "odhen";
        
        // Use Zeedhi's Acl
        window.useZhuAcl = true;
        
        // Devops Project Id
        window.projectId = 1776;
        
        // Acl's show filioper screen parameters
        window.showFullOperatorWindow = true;
        window.filialRuleInFullOperatorWindow = true;
        
        // Param to know this systems client.
        window.showMultipleFiliaisOnDashboard = ("<>RM_DASHBOARD_MULTIPLE_FILIAIS<>" == "true") ;
        
        // Tecfood's Corp Bool : (Used to know if the product is being used by a head office)  
        window.projectCorp = ("<>PROJECT_CORP_BOOL<>" == "true");
        
        // Next - Product Next Adress Configuration
        window.nextUrl = "<>NEXT_URL<>/";
        
        // Jenkins
        window.urlJenkins = "https://ci.teknisa.cloud";
        window.userJenkins = "luizsantos";
        window.tokenJenkins = "11656c8a5a5f83aac4a3ac294c10f2a4de";
    }
    
    function setUpBaseProductLocation () {
        
        // this var is used to find some images paths
        window.baseProductLocation = window.location.origin;
        
        if(window.serviceUrl.indexOf('service') != -1) {
            if(window.location.pathname.indexOf('modules') != -1) {
                window.baseProductLocation += window.location.pathname.split('modules')[0] + '';
            } else {
                window.baseProductLocation += window.location.pathname;
            }
        }
        
        window.defaultUserImageUrl = ("/" + "/assets/images/user.jpg").toString().replace(/\/\//g, '/');
    }
    
    function setUpPackages () {
        
        // Packages (Zeedhi's, MicroServices Modules and Submodules, etc.. )
        
        var pkgs = {
            "product":                                          "./assets",
            "modules":                                          "../../../assets",
            
            "zeedhiFramework":                                  "./bower_components/zeedhi-frontend/assets",
            
            "zhuacl":                                           "./bower_components/zhuaclfrontend/assets",
            "zhulog":                                           "./bower_components/zhulog/assets",
            
            "acl":                                              "/acl/assets/",
            "lib":                                              "./bower_components/tek-libraries",
            
            "cadCdp":                                           "/cadCdp/assets/",

            "cadCtb":                                           "/cadCtb/assets/",

            "cadEst":                                           "/cadEst/assets/",
            "cadEst_produto":                                   "/cadEst/assets/modules/produto/assets/",
            
            "cadExp":                                           "/cadExp/assets/",
            
            "cadFin":                                           "/cadFin/assets/",
            
            "cadFis":                                           "/cadFis/assets/",

            "cadPed":                                           "/cadPed/assets/",
            
            "cadSup":                                           "/cadSup/assets/",
            
            "cmp":                                              "/cmp/assets/",
            "cmp_relatorio":                                    "/cmp/assets/modules/relatorio/assets/",
            "cmp_cadastros":                                    "/cmp/assets/modules/cadastros/assets/",
            "cmp_fornecimento":                                 "/cmp/assets/modules/fornecimento/assets/",
            "cmp_solicitacao":                                  "/cmp/assets/modules/solicitacao/assets/",
            "cmp_parametros":                                   "/cmp/assets/modules/parametros/assets/",
            "cmp_fornecimento_apuracaoEfetivacao":              "/cmp/assets/modules/fornecimento/assets/modules/apuracaoEfetivacao/assets/",
            "cmp_fornecimento_autorizacaoFornecimento":         "/cmp/assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/",
            "cmp_fornecimento_emissaoAutorizacaoFornecimento":  "/cmp/assets/modules/fornecimento/assets/modules/emissaoAutorizacaoFornecimento/assets/",
            "cmp_fornecimento_listaPreco":                      "/cmp/assets/modules/fornecimento/assets/modules/listaPreco/assets/",
            "cmp_necessidadeCompras":                           "/cmp/assets/modules/necessidadeCompras/assets/",
            "cmp_solicitacao_relatorios":                       "/cmp/assets/modules/solicitacao/assets/modules/relatorios/assets/",
            "cmp_solicitacao_solicitacaoCompras":               "/cmp/assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/",
            
            "cnc":                                              "/cnc/assets/",
            
            "ctb":                                              "/ctb/assets/",
            "ctb_saldos":                                       "/ctb/assets/modules/saldos/assets/",
            
            "df":                                               "/df/assets/",
            "df_entrada":                                       "/df/assets/modules/entrada/assets/",
            "df_saida":                                         "/df/assets/modules/saida/assets/",
            "df_relatorios":                                    "/df/assets/modules/relatorios/assets/",
            "df_V1":                                            "/df/assets/modules/V1/assets/",
        
            "dro":                                              "/dro/assets/",
            
            "est":                                              "/est/assets/",
            "est_ajuste":                                       "/est/assets/modules/ajuste/assets/",
            "est_estoqueCego":                                  "/est/assets/modules/estoqueCego/assets/",
            "est_lancamentos":                                  "/est/assets/modules/lancamentos/assets/",
            "est_produto":                                      "/est/assets/modules/produto/assets/",
            "est_relatorios":                                   "/est/assets/modules/relatorios/assets/",
        
            "fin":                                              "/fin/assets/",
            "fin_contaPagar":                                   "/fin/assets/modules/contaPagar/assets/",
            "fin_contaReceber":                                 "/fin/assets/modules/contaReceber/assets/",
            "fin_fluxoCaixa":                                   "/fin/assets/modules/fluxoCaixa/assets/",
            "fin_movimentacaoBancaria":                         "/fin/assets/modules/movimentacaoBancaria/assets/",
            "fin_relatoriosBancarios":                          "/fin/assets/modules/relatoriosBancarios/assets/",
            "fin_relatoriosPagar":                              "/fin/assets/modules/relatoriosPagar/assets/",
            "fin_relatoriosReceber":                            "/fin/assets/modules/relatoriosReceber/assets/",
            "fin_retornoPagar":                                 "/fin/assets/modules/retornoPagar/assets/",
            "fin_retornoReceber":                               "/fin/assets/modules/retornoReceber/assets/",
        
            "fis":                                              "/fis/assets/",
            "fis_acessorias":                                   "/fis/assets/modules/acessorias/assets/",
            "fis_apuracoes":                                    "/fis/assets/modules/apuracoes/assets/",
            "fis_guias":                                        "/fis/assets/modules/guias/assets/",
            "fis_relatorios":                                   "/fis/assets/modules/relatorios/assets/", 
            
            "login":                                            "/login/assets/",

            "zh-preferences":                                   "bower_components/zh-preferences/dist/assets/",
            "zh-filter-preferences":                            "bower_components/zh-filter-preferences/dist/assets/",
            "zh-layout-preferences":                            "bower_components/zh-layout-preferences/dist/assets/",
            "zh-view-preferences":                              "bower_components/zh-view-preferences/dist/assets/",

            "man":                                              "/man/assets/",
            
            "cadGes":                                           "/cadGes/assets/",
            
            "dro":                                              "/dro/assets/",

            "par":                                              "/par/assets/",
            
            "sup":                                              "/sup/assets/",
            "sup_relatorio":                                    "/sup/assets/modules/relatorio/assets/",
            "sup_cadastros":                                    "/sup/assets/modules/cadastros/assets/",
            "sup_parametros":                                   "/sup/assets/modules/parametros/assets/",
            "sup_cotacao":                                      "/sup/assets/modules/cotacao/assets/",
            "sup_cotacao_analiseCotacoes":                      "/sup/assets/modules/cotacao/assets/modules/analiseCotacoes/assets/",
            "sup_cotacao_apuracao":                             "/sup/assets/modules/cotacao/assets/modules/apuracao/assets/",
            "sup_cotacao_listaPreco":                           "/sup/assets/modules/cotacao/assets/modules/listaPreco/assets/",
            "sup_cotacao_pedido":                               "/sup/assets/modules/cotacao/assets/modules/pedido/assets/",
            "sup_cotacao_planilhaCotacao":                      "/sup/assets/modules/cotacao/assets/modules/planilhaCotacao/assets/",
            "sup_fornecimento_autorizacaoFornecimento":         "/sup/assets/modules/fornecimento/assets/modules/autorizacaoFornecimento/assets/",
            "sup_fornecimento_emissaoAF":                       "/sup/assets/modules/fornecimento/assets/modules/emissaoAF/assets/",
            "sup_fornecimento_migracaoAF":                      "/sup/assets/modules/fornecimento/assets/modules/migracaoAF/assets/",
            "sup_fornecimento_relatorios":                      "/sup/assets/modules/fornecimento/assets/modules/relatorios/assets/",
            "sup_solicitacao_consolidacao":                     "/sup/assets/modules/solicitacao/assets/modules/consolidacao/assets/",
            "sup_solicitacao_relatorios":                       "/sup/assets/modules/solicitacao/assets/modules/relatorios/assets/",
            "sup_solicitacao_solicitacaoCompras":               "/sup/assets/modules/solicitacao/assets/modules/solicitacaoCompras/assets/",
            "sup_operadorLogistico":                            "/sup/assets/modules/operadorLogistico/assets/"
        };
        
        // Management's Teknisa Libs Base URL
        var libBackend = window.location.href.search('acl#') === -1 ? "/backend/index.php" : "/backend_acl/index.php";
        
        // Packages Base URL
        var pkgBaseUrls = {
            acl:        "/backend_acl/index.php",
            cadCdp:     "/backend_cadCdp/index.php", 
            cadCtb:     "/backend_cadCtb/index.php", 
            cadEst:     "/backend_cadEst/index.php", 
            cadExp:     "/backend_cadExp/index.php",  
            cadFin:     "/backend_cadFin/index.php",
            cadFis:     "/backend_cadFis/index.php",
            cadPed:     "/backend_cadPed/index.php",  
            cadSup:     "/backend_cadSup/index.php",  
            cadGes:     "/backend_cadGes/index.php",  
            cmp:        "/backend_cmp/index.php",  
            cnc:        "/backend_cnc/index.php",  
            ctb:        "/backend_ctb/index.php",  
            df:         "/backend_df/index.php",
            dro:        "/backend_dro/index.php",
            est:        "/backend_est/index.php",
            fin:        "/backend_fin/index.php",
            fis:        "/backend_fis/index.php", 
            man:        "/backend_man/index.php",
            par:        "/backend_par/index.php",  
            sup:        "/backend_sup/index.php",
            login:      "/backend_login/index.php",
            lib:        libBackend,
            product:    "/backend/index.php",
            default:    "/backend/index.php"
        };
        
        var hasAlias_Bool = true;
        if (hasAlias_Bool) {
            for (row in pkgBaseUrls){
                pkgBaseUrls[row] = location.origin+pkgBaseUrls[row].replace('../', '/').replace('//', '/');
            }
        }
        
        // Fills ServicesUrl's and MetadatasUrl's with Packages
        var getRealBaseKey = function(keyPkg) {
            var hasAlias = true;
    	    var module = window.location.pathname.replace(/\//g, "");
            return hasAlias? pkgBaseUrls.hasOwnProperty(keyPkg)? keyPkg 
                                : module? module 
                                    : 'product' 
                    : keyPkg === 'product'? keyPkg 
                        : 'default';
        };
    
        for (var key in pkgs) {
            metadataUrls.push({
                "package": key,
                "baseUrl": pkgs[key]
            });
            var keyPkg = key.split('_')[0];
            var realBaseKey = getRealBaseKey(keyPkg);
            var uri = pkgBaseUrls[realBaseKey];
            if (keyPkg.indexOf('-preferences') != -1) {
                uri +='/zh-preferences';
            }
            serviceUrls.push({
                "package": key,
                "baseUrl": uri
            });
        }
    }
    
    // Sets all component's templateUrls
    function setUpTemplateUrls() {
        
        window.templateUrls = window.templateUrls || [];
        
        var templateUrls = [
           {
                package: "zh-charts",
                baseUrl: "bower_components/zh-charts/dist/templates/"
            },
            {
                package: "zh-customizations-service",
                baseUrl: "bower_components/zh-customizations-service/src/templates/"
            },
            {
                package: "zh-reports",
                baseUrl: "bower_components/zh-reports/dist/templates/"
            },
            {
                package: "zh-interval-component",
                baseUrl: "bower_components/zh-interval-component/dist/templates/"
            },
            {
                package: 'zh-select-autocomplete',
                baseUrl: './bower_components/zh-select-autocomplete/dist/templates/'
            },
            {
                package: 'many-polygons',
                baseUrl: './templates/maps/'
            },
            {
                package: "zh-rich-text",
                baseUrl: "./bower_components/zh-rich-text/dist/templates/"
            },
            {
                package: "zh-file-uploader",
                baseUrl: "./bower_components/zh-image-uploader/dist/templates/"
            },
            {
                package: 'zhulog',
                baseUrl: './bower_components/zhulog/assets'
            },
            {
                package: 'thaw-analysis',
                baseUrl: './templates/thaw-analysis/'
            }
        ];
        
        templateUrls.forEach(function(templateUrl) {
            var unregistered = window.templateUrls.every(function(template) {
                return template.package !== templateUrl.package;
            });
        
            if(unregistered)
                window.templateUrls.push(templateUrl);
        });
    }
    
    setUpWindowConfigurations();
    setUpBaseProductLocation();
    setUpPackages();
    setUpTemplateUrls();

})();